library ebisu_cpp.test.test_cpp_class;

import 'package:args/args.dart';
import 'package:logging/logging.dart';
import 'package:unittest/unittest.dart';
// custom <additional imports>

import 'package:ebisu/ebisu.dart';
import 'package:ebisu_cpp/ebisu_cpp.dart';

// end <additional imports>

final _logger = new Logger('test_cpp_class');

// custom <library test_cpp_class>
// end <library test_cpp_class>
main([List<String> args]) {
  Logger.root.onRecord.listen(
      (LogRecord r) => print("${r.loggerName} [${r.level}]:\t${r.message}"));
  Logger.root.level = Level.OFF;
// custom <main>

  group('basic', () {
    final tag = true;
    final access = public;
    test('opOut $tag', () {
      final c = class_('c_1')
        ..isStreamable = false
        ..members.add(member('x')..type = 'std::string')
        ..members.add(member('y')..type = 'std::string')
        ..members.add(member('zing')..type = 'std::string'
            ..withCustomStreamable((cb) {
                  cb.snippets.add([
                    '// some customization',
                    'int x = 4',
                  ]);
                  print('Adding snippet to $cb');
                }))
        ..withOpOut((op) => op.cppAccess = access);
        ;

      // if access is not private there should be two access sections, the
      // first is *access*, the second private. Otherwise it's all private
      final tricky = access == private ? '' : 'private:';
      print(c.definition);
    });
  });
}